#include "Gilass.h"


void DAG::BFS()
{
	myqueue.push(root);
	Tree * temp;

	while(!myqueue.empty())
	{
		temp = myqueue.front();
		myqueue.pop();

		if((temp->left == NULL || temp->left->cherry == 1) && (temp->right == NULL || temp->right->cherry == 1))
		{
			if(temp->cherry == 0){
				temp->cherry = 1;
				cherries.push_back(temp);
			}
		}
		else
		{
			myqueue.push( temp->left);
			myqueue.push( temp->right);
		}
	}

	
}


bool DAG::isEqual( Tree* t1, Tree* t2)
{
	if ( t1->data != t2->data ) return false;
	if (( t1->left == NULL && t1->right == NULL ) && (t2->left == NULL && t2->right == NULL)) return true;
	
	bool left_check  = (t1->left->identical  == t2->left )||(t2->left->identical  == t1->left);
	bool right_check = (t1->right->identical == t2->right)||(t2->right->identical == t1->right);
	
	if ( left_check && right_check ) return true;
	else if(t1->data == '+' || t1->data == '*')
	{
		bool left_inverse = (t1->left->identical  == t2->right )||(t2->left->identical  == t1->right);
		bool right_inverse = (t1->right->identical  == t2->left )||(t2->right->identical  == t1->left);

		return (left_inverse && right_inverse);
	}

	return false;
}



void DAG::equal()
{
	while(!cherries.empty())
	{
		Tree* cur = cherries.front();
		Tree* end = cherries.back();
		numiden.push_back(Output(cur));
		// Iterate through list
		list<Tree*>::iterator iter = cherries.begin();
		iter++;
		
		while( iter != cherries.end() )
		{
			if ( isEqual( cur ,  *iter ) )
			{
				(*iter)->identical = cur;
				iter = cherries.erase( iter++);
				++((numiden[numiden.size() - 1]).val);
				continue;
			}
			iter++;
		}
		
		cherries.erase( cherries.begin() );
	}
}

void DAG::dagger()
{
	while(root->cherry == false)
	{
		BFS();
		equal();
	}
}


bool DAG::priority( char a, char b)
{
	switch(b){
	case ('*'):
	case ('/'):
		switch(a){
		case ('('):
		case ('+'):
		case ('-'):
			return false;
			break;
		case ('/'):
		case ('*'):
			return true;
			break;
		default:
			throw Except("CHAND TA FOHSHE ZESHT!!!");
			break;
		}
		break;

	case ('-'):
	case ('+'):
	case (')'):
		switch(a){
		case ('('):
			return false;
			break;
		case ('+'):
		case ('-'):
		case ('/'):
		case ('*'):
			return true;
			break;
		default:
			throw Except("CHAND TA FOHSHE ZESHT!!!");
			break;
		}
		break;

	case ('('):
		return false;
		break;

	default:
		throw Except("CHAND TA FOHSHE ZESHT!!!");
		break;
	}
}

Tree * DAG::myGenerate(string infix){
	vector<Tree *> tvect;
	vector<char> ovect;
	
	ovect.push_back('(');
	infix.operator +=(')');

	int end = infix.length();
	for(int count = 0;count < end;count++)
	{
		if(strchr("()+-/*",infix[count]))
		{
			while(priority(ovect[ovect.size() - 1],infix[count]))
			{
				Tree * head = new Tree(ovect[ovect.size() - 1]);
				ovect.pop_back();
				head->right = tvect[tvect.size() - 1];
				tvect.pop_back();
				head->left = tvect[tvect.size() - 1];
				tvect.pop_back();
				tvect.push_back(head);
			}

			if(infix[count] != ')')
				ovect.push_back(infix[count]);
			else
				ovect.pop_back();
		}else
			tvect.push_back(new Tree(infix[count]));
	}

	Tree * temp = tvect[tvect.size() - 1];
	tvect.pop_back();
	return temp;
}


DAG::DAG(string infix){
	root = myGenerate(infix);
	dagger();
}

DAG::~DAG(){
	delete4des(root);
}

int DAG::calculate(Tree * node)
{
	if(node->identical != NULL){
		if(node->identical->cherry != 0)
			calculate(node->identical);
		node->cherry = 0;
		node->result = node->identical->result;

		return node->identical->result;
	}

	if(node->data >= 'A' && node->data <= 'z' && node->cherry == 1)
	{
		cout << node->data << '?';
		cin >> node->result;
		node->cherry = false;
		return node->result;
	}

	if(node->cherry == 0)
		return node->result;

	int first = calculate(node->left);
	int second = calculate(node->right);

	switch (node->data){
	case '+':
		node->result = (first + second);
		break;
	case '-':
		node->result = (first - second);
		break;
	case '*':
		node->result = (first * second);
		break;
	case '/':
		if(second == 0)
			throw Except("DIVISION BY ZERO");

		node->result = (first / second);
		break;
	default:
		throw Except("CHAND TA!!");
		break;
	}

	node->cherry = false;
	return node->result;
}

void DAG::delete4des(Tree * where2del){
	if(where2del == NULL)
		return;

	delete4des(where2del->right);
	where2del->right = NULL;
	delete4des(where2del->left);
	where2del->left = NULL;
	delete where2del;
}

string DAG::statistic(){
	int end = numiden.size();
	string retval;

	if(numiden[0].val != 1){
		retval += infixpar(numiden[0].wherethehell);
		retval += "->";
		retval += intstring(numiden[0].val);
	}

	for (int count = 1;count < end;count++)
	{
		if(numiden[count].val != 1)
		{
			retval += ", ";
			retval += infixpar(numiden[count].wherethehell);
			retval += "->";
			retval += intstring(numiden[count].val);
		}
	}

	return retval;
}

string DAG::intstring(long int number){
	if(number == 0)
		return string("0");

	string temp;
	int count = 0;

	while(number != 0){
		temp += (number % 10) + '0';
		number /= 10;
	}

	string temp2;
	int mybegin = temp.length();

	for(count = mybegin - 1;count >= 0;count--)
		temp2 += temp[count];

	return temp2;
}

string DAG::infixpar(Tree * wow){
	if(wow == NULL)
		return "";

	string retvalue;
	retvalue += '(';
	retvalue += infixpar(wow->left);
	retvalue += wow->data;
	retvalue += infixpar(wow->right);
	retvalue += ')';

	return retvalue;
}
